diff --git a/gcc/m2/gm2-compiler/M2SymInit.mod b/gcc/m2/gm2-compiler/M2SymInit.mod
index 4c6035ae929..48f1b3d3288 100644
--- a/gcc/m2/gm2-compiler/M2SymInit.mod
+++ b/gcc/m2/gm2-compiler/M2SymInit.mod
@@ -39,7 +39,8 @@ FROM M2Error IMPORT InternalError ;
 FROM M2BasicBlock IMPORT BasicBlock,
                          InitBasicBlocks, InitBasicBlocksFromRange,
 			 KillBasicBlocks, FreeBasicBlocks,
-                         ForeachBasicBlockDo ;
+                         ForeachBasicBlockDo,
+                         GetBasicBlockStart, GetBasicBlockEnd ;
 
 IMPORT Indexing ;
 FROM Indexing IMPORT Index ;
@@ -1873,7 +1874,7 @@ END DetectTrash ;
    AppendEntry -
 *)
 
-PROCEDURE AppendEntry (Start, End: CARDINAL) ;
+PROCEDURE AppendEntry (bb: BasicBlock) ;
 VAR
    bbPtr: bbEntry ;
    high : CARDINAL ;
@@ -1881,13 +1882,13 @@ BEGIN
    high := Indexing.HighIndice (bbArray) ;
    bbPtr := NewEntry () ;
    WITH bbPtr^ DO
-      start := Start ;
-      end := End ;
+      start := GetBasicBlockStart (bb) ;
+      end := GetBasicBlockEnd (bb) ;
       first := high = 0 ;
-      endCall := IsCall (End) ;
-      endGoto := IsGoto (End) ;
-      endCond := IsConditional (End) ;
-      topOfLoop := IsBackReference (Start) ;
+      endCall := IsCall (end) ;
+      endGoto := IsGoto (end) ;
+      endCond := IsConditional (end) ;
+      topOfLoop := IsBackReference (start) ;
       trashQuad := 0 ;
       indexBB := high + 1 ;
       nextQuad := 0 ;
diff --git a/gcc/m2/gm2-compiler/P3Build.bnf b/gcc/m2/gm2-compiler/P3Build.bnf
index 643309424a7..0cec32914fc 100644
--- a/gcc/m2/gm2-compiler/P3Build.bnf
+++ b/gcc/m2/gm2-compiler/P3Build.bnf
@@ -679,9 +679,12 @@ ConstExpression :=                                                         % VAR
                                                                            % PopInConstExpression %
                 =:
 
-Relation := "="                                                            % PushTtok(EqualTok, GetTokenNo() -1) %
-            | "#"                                                          % PushTtok(HashTok, GetTokenNo() -1) %
-            | "<>"                                                         % PushTtok(LessGreaterTok, GetTokenNo() -1) %
+Relation := "="                                                            % PushTtok(EqualTok, GetTokenNo() -1) ;
+                                                                             RecordOp %
+            | "#"                                                          % PushTtok(HashTok, GetTokenNo() -1) ;
+                                                                             RecordOp %
+            | "<>"                                                         % PushTtok(LessGreaterTok, GetTokenNo() -1) ;
+                                                                             RecordOp %
             | "<"                                                          % PushTtok(LessTok, GetTokenNo() -1) %
             | "<="                                                         % PushTtok(LessEqualTok, GetTokenNo() -1) %
             | ">"                                                          % PushTtok(GreaterTok, GetTokenNo() -1) %
diff --git a/gcc/m2/gm2-compiler/SymbolTable.def b/gcc/m2/gm2-compiler/SymbolTable.def
index 06f8a227563..05ef313f322 100644
--- a/gcc/m2/gm2-compiler/SymbolTable.def
+++ b/gcc/m2/gm2-compiler/SymbolTable.def
@@ -392,6 +392,21 @@ PROCEDURE IsVarHeap (sym: CARDINAL) : BOOLEAN ;
 PROCEDURE MakeVar (tok: CARDINAL; VarName: Name) : CARDINAL ;
 
 
+(*
+   PutVarConditional - assign IsConditional to value.
+*)
+
+PROCEDURE PutVarConditional (sym: CARDINAL; value: BOOLEAN) ;
+
+
+(*
+   IsVarConditional - return TRUE if the symbol is a var symbol
+                      containing the result of a boolean conditional.
+*)
+
+PROCEDURE IsVarConditional (sym: CARDINAL) : BOOLEAN ;
+
+
 (*
    MakeRecord - makes a Record symbol with name RecordName.
 *)
diff --git a/gcc/m2/gm2-compiler/SymbolTable.mod b/gcc/m2/gm2-compiler/SymbolTable.mod
index f206a47dff7..c76e942f729 100644
--- a/gcc/m2/gm2-compiler/SymbolTable.mod
+++ b/gcc/m2/gm2-compiler/SymbolTable.mod
@@ -510,6 +510,8 @@ TYPE
                                               (* of const.                   *)
                     Value        : PtrToValue ; (* Value of the constant     *)
                     Type         : CARDINAL ; (* TYPE of constant, char etc  *)
+                    IsConditional,            (* Is it the result of a       *)
+                                              (* boolean conditional?        *)
                     IsSet        : BOOLEAN ;  (* is the constant a set?      *)
                     IsConstructor: BOOLEAN ;  (* is the constant a set?      *)
                     FromType     : CARDINAL ; (* type is determined FromType *)
@@ -533,6 +535,7 @@ TYPE
                IsComponentRef: BOOLEAN ;      (* Is temporary referencing a  *)
                                               (* record field?               *)
                list          : Indexing.Index ;  (* the record and fields    *)
+               IsConditional,
                IsTemp        : BOOLEAN ;      (* Is variable a temporary?    *)
                IsParam       : BOOLEAN ;      (* Is variable a parameter?    *)
                IsPointerCheck: BOOLEAN ;      (* Is variable used to         *)
@@ -4306,6 +4309,7 @@ BEGIN
             Scope := GetCurrentScope() ;  (* Procedure or Module?  *)
             AtAddress := FALSE ;
             Address := NulSym ;           (* Address at which declared.  *)
+            IsConditional := FALSE ;
             IsTemp := FALSE ;
             IsComponentRef := FALSE ;
             IsParam := FALSE ;
@@ -4334,6 +4338,52 @@ BEGIN
 END MakeVar ;
 
 
+(*
+   PutVarConditional - assign IsConditional to value.
+*)
+
+PROCEDURE PutVarConditional (sym: CARDINAL; value: BOOLEAN) ;
+VAR
+   pSym: PtrToSymbol ;
+BEGIN
+   pSym := GetPsym(sym) ;
+   WITH pSym^ DO
+      CASE SymbolType OF
+
+      VarSym     : Var.IsConditional := value |
+      ConstVarSym: ConstVar.IsConditional := value
+
+      ELSE
+         InternalError ('expecting Var')
+      END
+   END
+END PutVarConditional ;
+
+
+(*
+   IsVarConditional - return TRUE if the symbol is a var symbol
+                      containing the result of a boolean conditional.
+*)
+
+PROCEDURE IsVarConditional (sym: CARDINAL) : BOOLEAN ;
+VAR
+   pSym: PtrToSymbol ;
+BEGIN
+   pSym := GetPsym(sym) ;
+   WITH pSym^ DO
+      CASE SymbolType OF
+
+      VarSym     : RETURN Var.IsConditional |
+      ConstVarSym: RETURN ConstVar.IsConditional
+
+      ELSE
+         RETURN FALSE
+      END
+   END ;
+   RETURN FALSE
+END IsVarConditional ;
+
+
 (*
    PutExceptionBlock - sets a BOOLEAN in block module/procedure/defimp,
                        sym, indicating that this block as an EXCEPT
@@ -5043,6 +5093,7 @@ BEGIN
             Value := InitValue() ;
             Type  := NulSym ;
             IsSet := FALSE ;
+            IsConditional := FALSE ;
             IsConstructor := FALSE ;
             FromType := NulSym ;     (* type is determined FromType *)
             UnresFromType := FALSE ; (* is Type resolved?           *)
diff --git a/gcc/testsuite/gm2/iso/const/pass/constbool4.mod b/gcc/testsuite/gm2/iso/const/pass/constbool4.mod
new file mode 100644
index 00000000000..faf335eb85a
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/const/pass/constbool4.mod
@@ -0,0 +1,17 @@
+MODULE constbool4 ;
+
+
+CONST
+   World = "W" + "o" + "r" + "l" + "d" ;
+   Hello = "Hello" + " " + World ;
+   AddressableBits = 32 ;
+   MaxBits         = 32 ;
+
+   BitsInUse =
+    ORD(AddressableBits > MaxBits) * MaxBits +
+    ORD(AddressableBits <= MaxBits) * AddressableBits +
+    ORD (LENGTH (Hello) = 15) ;
+
+BEGIN
+
+END constbool4.
diff --git a/gcc/testsuite/gm2/iso/const/pass/constbool5.mod b/gcc/testsuite/gm2/iso/const/pass/constbool5.mod
new file mode 100644
index 00000000000..31b6de3bd5f
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/const/pass/constbool5.mod
@@ -0,0 +1,24 @@
+MODULE constbool5 ;
+
+FROM libc IMPORT printf, exit ;
+
+CONST
+   World = "W" + "o" + "r" + "l" + "d" ;
+   Hello = "Hello" + " " + World ;
+   AddressableBits = 32 ;
+   MaxBits         = 32 ;
+
+   BitsInUse =
+    ORD(AddressableBits > MaxBits) * MaxBits +
+    ORD(AddressableBits <= MaxBits) * AddressableBits +
+    ORD (LENGTH (Hello) = 11) ;
+
+BEGIN
+   IF BitsInUse = 33
+   THEN
+      printf ("passed\n") ;
+   ELSE
+      printf ("failed\n") ;
+      exit (1)
+   END
+END constbool5.
diff --git a/gcc/testsuite/gm2/iso/run/pass/condtest2.mod b/gcc/testsuite/gm2/iso/run/pass/condtest2.mod
new file mode 100644
index 00000000000..17ecd18102c
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/run/pass/condtest2.mod
@@ -0,0 +1,26 @@
+MODULE condtest2 ;
+
+FROM libc IMPORT printf, exit ;
+
+
+PROCEDURE test (VAR a, b, c, d: CARDINAL) ;
+BEGIN
+   IF (a = b) # (c = d)
+   THEN
+      printf ("passed\n")
+   ELSE
+      printf ("failed\n") ;
+      exit (1)
+   END
+END test ;
+
+
+VAR
+   e, f, g, h: CARDINAL ;
+BEGIN
+   e := 1 ;
+   f := 2 ;
+   g := 3 ;
+   h := 3 ;
+   test (e, f, g, h)
+END condtest2.
diff --git a/gcc/testsuite/gm2/iso/run/pass/condtest3.mod b/gcc/testsuite/gm2/iso/run/pass/condtest3.mod
new file mode 100644
index 00000000000..457a94f638d
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/run/pass/condtest3.mod
@@ -0,0 +1,26 @@
+MODULE condtest3 ;
+
+FROM libc IMPORT printf, exit ;
+
+
+PROCEDURE test ;
+CONST
+   a = 1 ;
+   b = 2 ;
+   c = 3 ;
+   d = 3 ;
+   Result = ((a = b) # (c = d)) ;
+BEGIN
+   IF Result
+   THEN
+      printf ("passed\n")
+   ELSE
+      printf ("failed\n") ;
+      exit (1)
+   END
+END test ;
+
+
+BEGIN
+   test
+END condtest3.
diff --git a/gcc/testsuite/gm2/iso/run/pass/condtest4.mod b/gcc/testsuite/gm2/iso/run/pass/condtest4.mod
new file mode 100644
index 00000000000..6fd027b12e2
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/run/pass/condtest4.mod
@@ -0,0 +1,24 @@
+MODULE condtest4 ;
+
+FROM libc IMPORT printf, exit ;
+
+
+PROCEDURE test (VAR a, b: BOOLEAN) ;
+BEGIN
+   IF a AND b
+   THEN
+      printf ("passed\n")
+   ELSE
+      printf ("failed\n") ;
+      exit (1)
+   END
+END test ;
+
+
+VAR
+   e, f: BOOLEAN ;
+BEGIN
+   e := TRUE ;
+   f := TRUE ;
+   test (e, f)
+END condtest4.
diff --git a/gcc/testsuite/gm2/iso/run/pass/condtest5.mod b/gcc/testsuite/gm2/iso/run/pass/condtest5.mod
new file mode 100644
index 00000000000..5cb88433eaa
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/run/pass/condtest5.mod
@@ -0,0 +1,24 @@
+MODULE condtest5 ;
+
+FROM libc IMPORT printf, exit ;
+
+
+PROCEDURE test (VAR a, b: BOOLEAN) ;
+BEGIN
+   IF (a = a) AND b
+   THEN
+      printf ("passed\n")
+   ELSE
+      printf ("failed\n") ;
+      exit (1)
+   END
+END test ;
+
+
+VAR
+   e, f: BOOLEAN ;
+BEGIN
+   e := TRUE ;
+   f := TRUE ;
+   test (e, f)
+END condtest5.
diff --git a/gcc/testsuite/gm2/iso/run/pass/constbool4.mod b/gcc/testsuite/gm2/iso/run/pass/constbool4.mod
new file mode 100644
index 00000000000..faf335eb85a
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/run/pass/constbool4.mod
@@ -0,0 +1,17 @@
+MODULE constbool4 ;
+
+
+CONST
+   World = "W" + "o" + "r" + "l" + "d" ;
+   Hello = "Hello" + " " + World ;
+   AddressableBits = 32 ;
+   MaxBits         = 32 ;
+
+   BitsInUse =
+    ORD(AddressableBits > MaxBits) * MaxBits +
+    ORD(AddressableBits <= MaxBits) * AddressableBits +
+    ORD (LENGTH (Hello) = 15) ;
+
+BEGIN
+
+END constbool4.

